package com.sun.net.ssl;

import java.security.KeyStoreException;
import java.security.KeyStore;
import java.security.NoSuchProviderException;
import java.security.NoSuchAlgorithmException;
import java.security.AccessController;
import java.security.Security;
import java.security.PrivilegedAction;
import java.security.Provider;

@Deprecated
public class TrustManagerFactory
{
    private Provider provider;
    private TrustManagerFactorySpi factorySpi;
    private String algorithm;
    
    public static final String getDefaultAlgorithm() {
        String s = (String)AccessController.doPrivileged(new PrivilegedAction<String>() {
            @Override
            public String run() {
                return Security.getProperty("sun.ssl.trustmanager.type");
            }
        });
        if (s == null) {
            s = "SunX509";
            return s;
        }
        return s;
    }
    
    protected TrustManagerFactory(TrustManagerFactorySpi factorySpi, Provider provider, String algorithm) {
        this.factorySpi = factorySpi;
        this.provider = provider;
        this.algorithm = algorithm;
    }
    
    public final String getAlgorithm() {
        return this.algorithm;
    }
    
    public static final TrustManagerFactory getInstance(String str) throws NoSuchAlgorithmException {
        try {
            Object[] impl = SSLSecurity.getImpl(str, "TrustManagerFactory", (String)null);
            return new TrustManagerFactory((TrustManagerFactorySpi)impl[0], (Provider)impl[1], str);
        }
        catch (NoSuchProviderException ex) {
            throw new NoSuchAlgorithmException(str + " not found");
        }
    }
    
    public static final TrustManagerFactory getInstance(String s, String s2) throws NoSuchAlgorithmException, NoSuchProviderException {
        if (s2 == null || s2.length() == 0) {
            throw new IllegalArgumentException("missing provider");
        }
        Object[] impl = SSLSecurity.getImpl(s, "TrustManagerFactory", s2);
        return new TrustManagerFactory((TrustManagerFactorySpi)impl[0], (Provider)impl[1], s);
    }
    
    public static final TrustManagerFactory getInstance(String s, Provider provider) throws NoSuchAlgorithmException {
        if (provider == null) {
            throw new IllegalArgumentException("missing provider");
        }
        Object[] impl = SSLSecurity.getImpl(s, "TrustManagerFactory", provider);
        return new TrustManagerFactory((TrustManagerFactorySpi)impl[0], (Provider)impl[1], s);
    }
    
    public final Provider getProvider() {
        return this.provider;
    }
    
    public void init(KeyStore keyStore) throws KeyStoreException {
        this.factorySpi.engineInit(keyStore);
    }
    
    public TrustManager[] getTrustManagers() {
        return this.factorySpi.engineGetTrustManagers();
    }
}
